From ace2200a6c1cd1b7c08ad16569a2333f8462bc1c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 14 2017 10:42:52 +0000
Subject: [PATCH 751/1001] Add and fix documentation


---

diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index ac50fd3..38da840 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -23,13 +23,19 @@ class WidgetParameter(object):
     :py:class:`WidgetParameter` objects returned by the widget's
     :py:meth:`~Widget.get_parameters` method.
 
+    The value of the parameter is stored in the database as the value returned
+    by the validator's :py:meth:`from_string` method.  It can thus be a string,
+    an integer, a list, a dict, or any JSON-serializable value.
+
     Attributes:
         name (str): The name of the parameter.
         label (str): A humanized name of the parameter, which will be shown in
             the UI.
         default: The default value if this parameter is not set.
-        validator (function): A validation function that will be called when
-            a user sets the parameter value.
+        validator (hubs.widgets.validators.Validator): A validator subclass
+            that will be used to convert the parameter value to and from
+            string, raising an exception if it is invalid. This attribute
+            points to the validator subclass, not an instance of the class.
         help (str): A help text that will be shown in the UI.
     """
 
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index b59ca25..18b86fd 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -7,19 +7,42 @@ import requests
 
 
 class Validator(object):
+    """Convert widget parameters to and from string, and validate their value.
+
+    Validators are used to convert
+    :py:class:`~hubs.widgets.base.WidgetParameter` values to and from string.
+    They will raise an exception if the value is invalid.
+
+    A validator is a subclass of the :py:class:`Validator` class and implements
+    two class methods: :py:meth:`from_string` and :py:meth:`to_string`.
+    """
 
     @classmethod
     def from_string(cls, value):
+        """Convert the value from a string to a JSON-serializable value.
+
+        The result of this function will be stored in the database for widget
+        parameters.
+        
+        Raises:
+            ValueError: The value is invalid. 
+        """
         if value is None:
             return ""
         return value
 
     @classmethod
     def to_string(cls, value):
+        """Convert the value to a string.
+
+        The result of this function will be used in the widget configuration
+        form fields.
+        """
         return value
 
 
 class Required(Validator):
+    """Raises an error if the value is ``False``-like."""
 
     @classmethod
     def from_string(cls, value):
@@ -29,6 +52,7 @@ class Required(Validator):
 
 
 class Text(Validator):
+    """Raises an error if the value can't be converted to unicode."""
 
     @classmethod
     def from_string(cls, value):
@@ -36,6 +60,7 @@ class Text(Validator):
 
 
 class Integer(Validator):
+    """Raises an error if the value can't be converted to an integer."""
 
     @classmethod
     def from_string(cls, value):
@@ -43,6 +68,7 @@ class Integer(Validator):
 
 
 class Link(Validator):
+    """Raises an error if the value doesn't look like a link."""
 
     @classmethod
     def from_string(cls, value):
@@ -51,6 +77,13 @@ class Link(Validator):
 
 
 class Username(Validator):
+    """Raises an error if the value isn't an existing username.
+
+    There must be a corresponding :py:class:`~hubs.models.User` record.
+
+    This validator does not return the User instance because it is not
+    JSON-serializable, it returns the username unchanged.
+    """
 
     @classmethod
     def from_string(cls, value):
@@ -60,6 +93,7 @@ class Username(Validator):
 
 
 class GithubOrganization(Validator):
+    """Fails if the Github organization name does not exist."""
 
     @classmethod
     def from_string(cls, value):
@@ -68,6 +102,7 @@ class GithubOrganization(Validator):
 
 
 class GithubRepo(Validator):
+    """Fails if the Github repository name does not exist."""
 
     @classmethod
     def from_string(cls, value):
@@ -76,6 +111,7 @@ class GithubRepo(Validator):
 
 
 class FMNContext(Validator):
+    """Fails if the value is not a valid FMN context name."""
 
     @classmethod
     def from_string(cls, value):
@@ -87,6 +123,7 @@ class FMNContext(Validator):
 
 
 class PagureRepo(Validator):
+    """Fails if the Pagure repository name does not exist."""
 
     @classmethod
     def from_string(cls, value):
@@ -97,6 +134,7 @@ class PagureRepo(Validator):
 
 
 class FedorahostedProject(Validator):
+    """Fails if the FedoraHosted project name does not exist."""
 
     @classmethod
     def from_string(cls, value):

